%define anolis_release 2
Summary: Garbage collector for C and C++
Name:    gc
Version: 8.2.2
Release: %{anolis_release}%{dist}

License: BSD
URL:     https://www.hboehm.info/gc/
Source0: https://github.com/ivmai/bdwgc/releases/download/v%{version}/gc-%{version}.tar.gz

# Already upstream: https://github.com/ivmai/bdwgc/commit/4489757f1cc1fe4aa98d4c1ebbe0789b2b308e11
Patch0: pthread_setname_np.patch

BuildRequires: automake libtool
BuildRequires: gcc-c++
BuildRequires: make

Obsoletes: libgc < %{version}-%{release}
Provides:  libgc = %{version}-%{release}

%description
The Boehm-Demers-Weiser conservative garbage collector can be
used as a garbage collecting replacement for C malloc or C++ new.

%package devel
Summary: Libraries and header files for %{name} development
Requires: %{name} = %{version}-%{release}
Obsoletes: libgc-devel < %{version}-%{release}
Provides:  libgc-devel = %{version}-%{release}
%description devel
%{summary}.


%prep
%autosetup -n gc-%{version} -p1


%build
# refresh auto*/libtool to purge rpaths
rm -f libtool libtool.m4
autoreconf -i -f

CPPFLAGS="-DUSE_GET_STACKBASE_FOR_MAIN $CPPFLAGS"
# https://github.com/ivmai/bdwgc/commit/3ea130ae326d02e224921017d3ee9c287fd4e670
CPPFLAGS="-DDONT_UNDEF_EXCEPTIONS $CPPFLAGS"
export CPPFLAGS

%configure \
  --disable-docs \
  --enable-cplusplus \
  --enable-large-config \
  --enable-threads=posix

%make_build


%install
%make_install

install -p -D -m644 doc/gc.man  %{buildroot}%{_mandir}/man3/gc.3

## Unpackaged files
rm -rfv %{buildroot}%{_datadir}/gc/

%generate_compatibility_deps

%check
%ifnarch aarch64
make check %{?arch_ignore}
%endif


%files
%dir %{abidir}
%{_libdir}/libcord.so.1*
%{_libdir}/libgc.so.1*
%{_libdir}/libgccpp.so.1*
%{_libdir}/libgctba.so*
%{abidir}/libcord.dump
%{abidir}/libgc.dump
%{abidir}/libgccpp.dump
%{abidir}/libgctba.dump

%files devel
%doc doc/README.environment doc/README.linux
%doc doc/*.md
%{_includedir}/gc.h
%{_includedir}/gc_cpp.h
%{_includedir}/gc/
%{_libdir}/libcord.so
%{_libdir}/libgc.so
%{_libdir}/libgctba.so*
%{_libdir}/libgccpp.so
%{_libdir}/pkgconfig/bdw-gc.pc
%{_mandir}/man3/gc.3*


%changelog
* Tue Mar 28 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 8.2.2-2
- Del Specific Fields

* Wed Jan 18 2023 Funda Wang <fundawang@yeah.net> - 8.2.2-1
- New version 8.2.2

* Thu Oct 27 2022 mgb01105731 <mgb01105731@alibaba-inc.com> - 8.2.0-3
- optimise spec file

* Thu Apr 21 2022 Zhongling He <zhonglingh@linux.alibaba.com> - 8.2.0-2
- Backport c876dc2 from upstream to fix some headers not installed.

* Wed Apr 13 2022 Zhongling He <zhonglingh@linux.alibaba.com> - 8.2.0-1
- Init package from upstream v8.2.0
